/*
 * @Author: your name
 * @Date: 2021-09-28 12:48:40
 * @LastEditTime: 2021-09-29 13:47:50
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: 
 */
#pragma once
#include "BA_Enum_List.h"
#include "common_BA.h"

namespace BA
{
   class behaviorNodeGlobal
   {
   public:
      behaviorNodeGlobal() = default;
      void set_DurationTimeArr();
      uint32_t firstCorridor()
      {
         return m_FirstCorridorID;
      }
      float totalDurationTime()
      {
         return m_TotalDurationTime;
      }
      void set_IsNodeTerminated(bool isNodeTerminated)
      {
         m_IsNodeTerminated = isNodeTerminated;
      }
      float totalCost()
      {
         return m_TotalCost;
      }
      BA_ActionTyp firstActionTyp()
      {
         if (m_ActionTypArr.size() > 1)
         {
            return m_ActionTypArr[1]; // 2021/12/14: index should be 1, 0 denotes optimal action in last cycle
         }
         else
         {
            return BA::BA_ActionTyp_None;
         }
      }
      uint8_t firstTargetObjID()
      {
         if (m_TargetObjIDArr.size() > 1)
         {
            return m_TargetObjIDArr[1]; // 2021/12/14: index should be 1, 0 denotes optimal action in last cycle
         }
         else
         {
            return 0;
         }
      }
      BA::Index firstPassageID()
      {
         return m_FirstPassageID;
      }
      BA::Index nodeID()
      {
         return m_NodeID;
      }
      bool isNodeTerminated()
      {
         return m_IsNodeTerminated;
      }
      void targetLaneID(uint8_t &trgtLaneStID, uint8_t &trgtLaneEndID);
      bool getSpdLmtFlg()
      {
         return m_SpdLmtFlg;
      }
      float getSpdLmtDst()
      {
         return m_SpdLmtDst;
      }
      float getSpdLmtVal()
      {
         return m_SpdLmtVal;
      }
      BA::SpdLmtTyp getSpdLmtTyp()
      {
         return m_SpdLmtTyp;
      }
      uint8_t getSpdLmtID()
      {
         return m_SpdLmtID;
      }

   // private:
      BA::Index m_NodeID;
      float m_TotalCost;   // accumulation
      float m_ProcessCost; // accumulation
      float m_BACalcCost; // represent costs calculated by BA
      float m_BACalcGlobalCost; // represent global cost calculated by BA
      std::vector<float> m_DurationTimeArr;
      std::vector<BA_ActionTyp> m_ActionTypArr;
      std::vector<uint32_t> m_CorridorIDArr;
      std::vector<uint32_t> m_TargetObjIDArr;
      HV_Info m_HVInfoGlobal;
      uint32_t m_FirstCorridorID;
      bool m_IsNodeTerminated;
      float m_TotalDurationTime;
      BA::Index m_FirstPassageID;
      float m_SpdLmtVal = 40.0f;
      float m_SpdLmtDst = 1000.0f;
      bool m_SpdLmtFlg = false;
      BA::SpdLmtTyp m_SpdLmtTyp = BA::SpdLmtTyp_NotAvlbl;
      uint8_t m_SpdLmtID = uint8_t(0);
   };
}